////////////////////////////////////////////////////////////////////////////////////////////////////////
//Mit creative01B können verschiedenfarbige Blüten/Schmetterlinge erzeugt werden
//Linksklick: Weitere Blüten zeichnen. Rechtsklick: Stopp
//Taste 'n' Neustart
////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList <Bluete> Blueten;

float noiseVariable = 0.0;
float alpha = 0;
float delta = 0.005;//je größer desto stärker die Schwankungen in noise
int vz = 1;
int i=0;
float rMittel = 40;
float xRAlt,yRAlt;
float xRNeu,yRNeu;
float rNeu = 0;
float rAlt = rMittel;
float xM,yM;
boolean klein = false;
float r1,g1,b1;
float r2,g2,b2;
color farbe ;
color farbeMitTransparenz;
float S1 ; 
float S2 ; 
int max,index;
boolean neustart = false;
boolean stopp = true;//Startet erst auf Mausklick

void setup(){
  size(800,800);
  background(0); 
  max =100;
  index = 0;
  Blueten = new ArrayList();
  
  for (int i = 0; i<max; i++) {
    farbe = color(random(255),random(255),random(255));
    farbeMitTransparenz = color(farbe,30);
    Blueten.add(new Bluete(random(width), random(height), farbeMitTransparenz));
  }
  xM = random(10,750);
  yM = random(10,750);
  strokeWeight(1);
  xRAlt = xM + rAlt;
  yRAlt = yM;
  
}

void draw() {
  if(neustart){
    background(0);
    neustart = false;
  }
  Bluete b = Blueten.get(index);
  if(!stopp) {
    b.zeichne();
  }
  index++;
  if(index == max) noLoop();
}


////////////////////////////////////////////////////////////////////
void mousePressed() { 
  if (mouseButton == RIGHT) {
    noLoop();
  }
  if (mouseButton == LEFT){  
    index =0;
    stopp = false;
    Blueten = new ArrayList();
    for (int i = 0; i<max; i++) {
      farbe = color(random(255),random(255),random(255));
      farbeMitTransparenz = color(farbe,30);
      Blueten.add(new Bluete(random(width), random(height), farbeMitTransparenz));
    }
  xM = random(50,750);
  yM = random(50,750);
  strokeWeight(1);
  xRAlt = xM + rAlt;
  yRAlt = yM;
  loop();
  }
  
}
////////////////////////////////////////////////////////////////////////
void keyPressed() {
   if (key == 's') {
     saveFrame("Blueten###.png");println("Bild gespeichert");
     redraw();
   }
   if (key == 'n') {
     if(delta == 0.005) delta = 0.03;  //stärkeres noise
     else delta = 0.005;
     index = 0;
     neustart = true;
     println("Neustart");
     stopp = false;
     loop(); 
   }
}  
/////////////////////////////////////////////////////////////////////////////////////////////////////  
class Bluete { //...oder Stern
  float xM,yM;
  color farbe;
  int i = 0;
  
  public Bluete(float x, float y, color farbe) {
    xM =x;
    yM =y;
    this.farbe =farbe;
    
  }
    
  void zeichne(){
    for(i=0; i<3000;i++){
      noiseVariable = noiseVariable + delta;
      rNeu =-100*sin(i/50.0)+ rMittel ;
      rNeu = rNeu + width/4.0*sin(i/50.0)*noise(noiseVariable);
      xRNeu = xM + rNeu*cos(alpha);
      yRNeu = yM + rNeu*sin(alpha);
      stroke(farbe);
      if(i>0) line(xM,yM, xRNeu, yRNeu);
      xRAlt = xRNeu;
      yRAlt = yRNeu;
      rAlt = rNeu;
      if(random(0,1) < 0.005) vz = -vz;//links/rechts drehend
      if(random(0,1) < 0.005) alpha = alpha+PI;//180 Grad Sprung
      alpha+= vz*delta;
      i++;   
    }
  }
   
}
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
